-- Prozedur/Funktion PROC_DEL_ELEMENT_GEOMETRY erstellen.
create or replace PROCEDURE PROC_DEL_ELEMENT_GEOMETRY 
	(pELEMENT IN NUMBER) IS 
cursor edgeline (pELEMENT number) is 
	select EDGELINE from EDGELINE 
	where (ELEMENT = pELEMENT); 
begin -- main
	delete from FACE where ELEMENT = pELEMENT; 
	delete from EXTRUSION where ELEMENT = pELEMENT; 
	for e in edgeline(pELEMENT) loop 
		delete from EDGETO where EDGELINE = e.EDGELINE; 
		delete from EDGELINECONNECT where MASTER = e.EDGELINE or SLAVE = e.EDGELINE; 
	end loop; 
	delete from EDGELINE where ELEMENT = pELEMENT; 
	delete from USERDEF_EDGETYPE where ELEMENT = pELEMENT; 
	delete from VERTEX where ELEMENT = pELEMENT; 
end;
/

-- Prozedur/Funktion PROC_DEL_ELEMENT_TEXTURE erstellen.
create or replace procedure PROC_DEL_ELEMENT_TEXTURE 
	(pELEMENT IN NUMBER) IS  
begin -- main
	declare
		exist NUMBER;
		cursor texs (pELEMENT number) is
			select TEXTURE from TEXTURE
			where (ELEMENT = pELEMENT);
		cursor col (pTEXTURE number) is
			select COLOR from TEXTURE
			where (TEXTURE=pTEXTURE);
	begin
		for e in texs(pELEMENT)	loop
			update FACE set TEXTURE = NULL where TEXTURE = e.TEXTURE;
			for c in col(e.TEXTURE) loop
				update TEXTURE set COLOR=null where COLOR=c.COLOR;
				delete from COLOR where COLOR=c.COLOR;
			end loop;
		end loop;
		delete from TEXTURE where ELEMENT = pELEMENT;
		delete from TEXCOORD where ELEMENT = pELEMENT;
    end;
end;
/

-- Prozedur/Funktion PROC_DEL_ELEMENT erstellen.
CREATE OR REPLACE  PROCEDURE PROC_DEL_ELEMENT 
	(pELEMENT IN NUMBER) IS 
begin -- main
	PROC_DEL_ELEMENT_GEOMETRY(pELEMENT); 
	PROC_DEL_ELEMENT_TEXTURE(pELEMENT); 
	update ELEMENT set LOWERLOD = NULL where LOWERLOD = pELEMENT; 
	delete from ELEMENT where ELEMENT = pELEMENT; 
end;
/

-- Prozedur/Funktion PROC_DEL_ELEMENTCOMPLEX erstellen.
CREATE OR REPLACE  PROCEDURE PROC_DEL_ELEMENTCOMPLEX 
	(pELEMENTCOMPLEX IN NUMBER) IS 
cursor elements (pELEMENT number) is 
	select ELEMENT from ELEMENT 
	where (ELEMENTCOMPLEX = pELEMENTCOMPLEX); 
begin -- main
	for e in elements(pELEMENTCOMPLEX) loop 
		PROC_DEL_ELEMENT(e.ELEMENT); 
	end loop; 
	delete from ELEMENTCOMPLEX where ELEMENTCOMPLEX=pELEMENTCOMPLEX; 
end;
/

-- Prozedur/Funktion PROC_DEL_OBJECT erstellen.
create or replace PROCEDURE PROC_DEL_OBJECT 
	(pOBJECT IN NUMBER) IS 
cursor ElementComplexes (pOBJECT number) is 
	select ELEMENTCOMPLEX from ELEMENTCOMPLEX 
	where (OBJECT = pOBJECT);
begin -- main
	update ELEMENTCOMPLEX set PARENT=null where (OBJECT = pOBJECT); 
	for e in ElementComplexes(pOBJECT) loop 
		PROC_DEL_ELEMENTCOMPLEX(e.ELEMENTCOMPLEX); 
	end loop; 
	delete from OBJECT where OBJECT=pOBJECT; 
end;
/

-- Prozedur/Funktion PROC_DEL_UNIT erstellen.
create or replace procedure PROC_DEL_UNIT 
	(pUNIT IN NUMBER) IS 
cursor objects (pUNIT number) is 
	select OBJECT from OBJECT 
	where (UNIT = pUNIT); 
begin -- main
	for obj in objects(pUNIT) loop 
		PROC_DEL_OBJECT(obj.OBJECT); 
	end loop; 
	delete from UNITVERSION where UNIT = pUnit; 
	delete from MODELUNIT where UNIT = pUNIT; 
	delete from UNIT where UNIT = pUNIT; 
end;
/

-- Prozedur/Funktion PROC_DEL_UNITVERSION erstellen.
create or replace procedure PROC_DEL_UNITVERSION 
	(pUNITVERSION IN NUMBER) IS 
cursor objects (pUNITVERSION number) is 
	select OBJECT from OBJECT
	where (UNITVERSION = pUNITVERSION); 
begin -- main
	for obj in objects(pUNITVERSION) loop 
		PROC_DEL_OBJECT(obj.OBJECT); 
	end loop; 
	delete from UNITVERSION where UNITVERSION.UNITVERSION = pUNITVERSION; 
end;
/

-- Prozedur/Funktion PROC_DEL_MODEL erstellen.
create or replace procedure PROC_DEL_MODEL
	(pMODEL IN NUMBER) IS 
begin -- main
	delete from MODELUNIT where MODEL = pMODEL; 
	delete from MODELIMAGE where MODEL = pMODEL; 
	delete from MODELAREA where MODEL = pMODEL; 
	delete from MODEL where MODEL = pMODEL; 
end;
/
